/*
 * Created on 2004/06/02
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package Kazoku;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;

import org.boxed_economy.besp.model.fmfw.behavior.Event;
import org.boxed_economy.besp.model.fmfw.behavior.GuardCondition;

/**
* AbstractCheckingBehavior
*/
public abstract class AbstractCheckingBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState waitingForTime =
			factory.createCompositeState("WaitingForTime");
		CompositeState waitingForReply =
			factory.createCompositeState("WaitingForReply");
		CompositeState watingForAskIkura =
			factory.createCompositeState("WatingForAskIkura");
		CompositeState watingForOrder =
			factory.createCompositeState("WatingForOrder");
		CompositeState watingForStudying =
			factory.createCompositeState("WatingForStudying");

		//actions
		Action payingMoneyAction = new Action() {
			public void doAction() {
				payingMoneyAction();
			}
			public String toString() {
				return "payingMoneyAction";
			}
		};
		Action tellingNannennAction = new Action() {
			public void doAction() {
				tellingNannennAction();
			}
			public String toString() {
				return "tellingNannennAction";
			}
		};
		Action checkingAction = new Action() {
			public void doAction() {
				checkingAction();
			}
			public String toString() {
				return "checkingAction";
			}
		};
		Action tellingIkuraAction = new Action() {
			public void doAction() {
				tellingIkuraAction();
			}
			public String toString() {
				return "tellingIkuraAction";
			}
		};
		Action tellingGohoubiAction = new Action() {
			public void doAction() {
				tellingGohoubiAction();
			}
			public String toString() {
				return "tellingGohoubiAction";
			}
		};

		//guard-conditions
		GuardCondition isHourInformation = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isHourInformation(e);
			}
		};

		//transitions
		Transition transitionWaitingForTimeToWaitingForReply =
			factory.createTransition();
		Transition transitionWatingForAskIkuraToWatingForOrder =
			factory.createTransition();
		Transition transitionWaitingForReplyToWatingForAskIkura =
			factory.createTransition();
		Transition transitionInitialStateToWaitingForTime =
			factory.createTransition();
		Transition transitionWatingForOrderToWatingForStudying =
			factory.createTransition();
		Transition transitionWatingForStudyingToWaitingForTime =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(waitingForTime);
		this.addState(waitingForReply);
		this.addState(watingForAskIkura);
		this.addState(watingForOrder);
		this.addState(watingForStudying);

		//transitions setting
		transitionWaitingForTimeToWaitingForReply.setEvent(TimeEvent.class);
		transitionWaitingForTimeToWaitingForReply.addAction(checkingAction);
		transitionWatingForAskIkuraToWatingForOrder.setEvent(
			ChannelEvent.class);
		transitionWatingForAskIkuraToWatingForOrder.addAction(
			tellingIkuraAction);
		transitionWaitingForReplyToWatingForAskIkura.setEvent(
			ChannelEvent.class);
		transitionWaitingForReplyToWatingForAskIkura.addAction(
			tellingGohoubiAction);
		transitionWatingForOrderToWatingForStudying.setEvent(
			ChannelEvent.class);
		transitionWatingForOrderToWatingForStudying.setGuardCondition(
			isHourInformation);
		transitionWatingForOrderToWatingForStudying.addAction(
			tellingNannennAction);
		transitionWatingForStudyingToWaitingForTime.setEvent(
			ChannelEvent.class);
		transitionWatingForStudyingToWaitingForTime.addAction(
			payingMoneyAction);

		//connection of transitions
		transitionWaitingForTimeToWaitingForReply.setSourceState(
			waitingForTime);
		transitionWaitingForTimeToWaitingForReply.setTargetState(
			waitingForReply);
		transitionWatingForAskIkuraToWatingForOrder.setSourceState(
			watingForAskIkura);
		transitionWatingForAskIkuraToWatingForOrder.setTargetState(
			watingForOrder);
		transitionWaitingForReplyToWatingForAskIkura.setSourceState(
			waitingForReply);
		transitionWaitingForReplyToWatingForAskIkura.setTargetState(
			watingForAskIkura);
		transitionInitialStateToWaitingForTime.setSourceState(initialState);
		transitionInitialStateToWaitingForTime.setTargetState(waitingForTime);
		transitionWatingForOrderToWatingForStudying.setSourceState(
			watingForOrder);
		transitionWatingForOrderToWatingForStudying.setTargetState(
			watingForStudying);
		transitionWatingForStudyingToWaitingForTime.setSourceState(
			watingForStudying);
		transitionWatingForStudyingToWaitingForTime.setTargetState(
			waitingForTime);

	}

	/**
	*payingMoneyAction
	*/
	protected abstract void payingMoneyAction();
	/**
	*tellingNannennAction
	*/
	protected abstract void tellingNannennAction();
	/**
	*checkingAction
	*/
	protected abstract void checkingAction();
	/**
	*tellingIkuraAction
	*/
	protected abstract void tellingIkuraAction();
	/**
	*tellingGohoubiAction
	*/
	protected abstract void tellingGohoubiAction();
	/**
	*isHourInformation
	*/
	protected abstract boolean isHourInformation(Event e);
}
