/*
 * Created on 2004/06/03
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package Kazoku;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.Event;
import org.boxed_economy.besp.model.fmfw.behavior.GuardCondition;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

/**
* AbstractStudyingBehavior
*/
public abstract class AbstractStudyingBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState waitingForMom =
			factory.createCompositeState("WaitingForMom");
		CompositeState waitingForMom_sAsk =
			factory.createCompositeState("WaitingForMom'sAsk");
		CompositeState watingForAnswer =
			factory.createCompositeState("WatingForAnswer");
		CompositeState waitingForIkuraAnswer =
			factory.createCompositeState("WaitingForIkuraAnswer");
		CompositeState watingForOkozukai =
			factory.createCompositeState("WatingForOkozukai");

		//actions
		Action receivingOkozukaiAction = new Action() {
			public void doAction() {
				receivingOkozukaiAction();
			}
			public String toString() {
				return "receivingOkozukaiAction";
			}
		};
		Action sayingYesAction = new Action() {
			public void doAction() {
				sayingYesAction();
			}
			public String toString() {
				return "sayingYesAction";
			}
		};
		Action askingOkozukaiAction = new Action() {
			public void doAction() {
				askingOkozukaiAction();
			}
			public String toString() {
				return "askingOkozukaiAction";
			}
		};
		Action sayingHourAction = new Action() {
			public void doAction() {
				sayingHourAction();
			}
			public String toString() {
				return "sayingHourAction";
			}
		};
		Action studyingAction = new Action() {
			public void doAction() {
				studyingAction();
			}
			public String toString() {
				return "studyingAction";
			}
		};

		//guard-conditions
		GuardCondition isMoneyGoods = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isMoneyGoods(e);
			}
		};
		GuardCondition isOkozukaiInformation = new GuardCondition() {
			public boolean isMatched(Event e) {
				return isOkozukaiInformation(e);
			}
		};

		//transitions
		Transition transitionWaitingForIkuraAnswerToWatingForOkozukai =
			factory.createTransition();
		Transition transitionWaitingForMom_sAskToWatingForAnswer =
			factory.createTransition();
		Transition transitionInitialStateToWaitingForMom =
			factory.createTransition();
		Transition transitionWatingForOkozukaiToWaitingForMom =
			factory.createTransition();
		Transition transitionWaitingForMomToWaitingForMom_sAsk =
			factory.createTransition();
		Transition transitionWatingForAnswerToWaitingForIkuraAnswer =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(waitingForMom);
		this.addState(waitingForMom_sAsk);
		this.addState(watingForAnswer);
		this.addState(waitingForIkuraAnswer);
		this.addState(watingForOkozukai);

		//transitions setting
		transitionWaitingForIkuraAnswerToWatingForOkozukai.setEvent(
			ChannelEvent.class);
		transitionWaitingForIkuraAnswerToWatingForOkozukai.addAction(
			studyingAction);
		transitionWaitingForMom_sAskToWatingForAnswer.setEvent(
			ChannelEvent.class);
		transitionWaitingForMom_sAskToWatingForAnswer.addAction(
			askingOkozukaiAction);
		transitionWatingForOkozukaiToWaitingForMom.setEvent(ChannelEvent.class);
		transitionWatingForOkozukaiToWaitingForMom.setGuardCondition(
			isMoneyGoods);
		transitionWatingForOkozukaiToWaitingForMom.addAction(
			receivingOkozukaiAction);
		transitionWaitingForMomToWaitingForMom_sAsk.setEvent(
			ChannelEvent.class);
		transitionWaitingForMomToWaitingForMom_sAsk.addAction(sayingYesAction);
		transitionWatingForAnswerToWaitingForIkuraAnswer.setEvent(
			ChannelEvent.class);
		transitionWatingForAnswerToWaitingForIkuraAnswer.setGuardCondition(
			isOkozukaiInformation);
		transitionWatingForAnswerToWaitingForIkuraAnswer.addAction(
			sayingHourAction);

		//connection of transitions
		transitionWaitingForIkuraAnswerToWatingForOkozukai.setSourceState(
			waitingForIkuraAnswer);
		transitionWaitingForIkuraAnswerToWatingForOkozukai.setTargetState(
			watingForOkozukai);
		transitionWaitingForMom_sAskToWatingForAnswer.setSourceState(
			waitingForMom_sAsk);
		transitionWaitingForMom_sAskToWatingForAnswer.setTargetState(
			watingForAnswer);
		transitionInitialStateToWaitingForMom.setSourceState(initialState);
		transitionInitialStateToWaitingForMom.setTargetState(waitingForMom);
		transitionWatingForOkozukaiToWaitingForMom.setSourceState(
			watingForOkozukai);
		transitionWatingForOkozukaiToWaitingForMom.setTargetState(
			waitingForMom);
		transitionWaitingForMomToWaitingForMom_sAsk.setSourceState(
			waitingForMom);
		transitionWaitingForMomToWaitingForMom_sAsk.setTargetState(
			waitingForMom_sAsk);
		transitionWatingForAnswerToWaitingForIkuraAnswer.setSourceState(
			watingForAnswer);
		transitionWatingForAnswerToWaitingForIkuraAnswer.setTargetState(
			waitingForIkuraAnswer);

	}

	/**
	*receivingOkozukaiAction
	*/
	protected abstract void receivingOkozukaiAction();
	/**
	*sayingYesAction
	*/
	protected abstract void sayingYesAction();
	/**
	*askingOkozukaiAction
	*/
	protected abstract void askingOkozukaiAction();
	/**
	*sayingHourAction
	*/
	protected abstract void sayingHourAction();
	/**
	*studyingAction
	*/
	protected abstract void studyingAction();
	/**
	*isMoneyGoods
	*/
	protected abstract boolean isMoneyGoods(Event e);
	/**
	*isOkozukaiInformation
	*/
	protected abstract boolean isOkozukaiInformation(Event e);
}
